# coding: utf-8

"""
    Arthur Scope

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List
from scope_client.api_bindings.models.metrics_arg_spec import MetricsArgSpec
from typing import Optional, Set
from typing_extensions import Self

class AggregationSpec(BaseModel):
    """
    AggregationSpec
    """ # noqa: E501
    aggregation_id: StrictStr = Field(description="Unique identifier of the aggregation.")
    aggregation_init_args: List[MetricsArgSpec] = Field(description="List of arguments to the aggregation's init function.")
    aggregation_args: List[MetricsArgSpec] = Field(description="List of arguments to the aggregation's aggregate function.")
    __properties: ClassVar[List[str]] = ["aggregation_id", "aggregation_init_args", "aggregation_args"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AggregationSpec from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in aggregation_init_args (list)
        _items = []
        if self.aggregation_init_args:
            for _item_aggregation_init_args in self.aggregation_init_args:
                if _item_aggregation_init_args:
                    _items.append(_item_aggregation_init_args.to_dict())
            _dict['aggregation_init_args'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in aggregation_args (list)
        _items = []
        if self.aggregation_args:
            for _item_aggregation_args in self.aggregation_args:
                if _item_aggregation_args:
                    _items.append(_item_aggregation_args.to_dict())
            _dict['aggregation_args'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AggregationSpec from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "aggregation_id": obj.get("aggregation_id"),
            "aggregation_init_args": [MetricsArgSpec.from_dict(_item) for _item in obj["aggregation_init_args"]] if obj.get("aggregation_init_args") is not None else None,
            "aggregation_args": [MetricsArgSpec.from_dict(_item) for _item in obj["aggregation_args"]] if obj.get("aggregation_args") is not None else None
        })
        return _obj


